#ifndef _TMTOOLS_H_
#define _TMTOOLS_H_

#include "clientapi.h"


//unix headers
#include <iostream>
#include <string.h>
#include <errno.h>
#include <string.h>
#include <iostream>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdarg.h>
#include <stdio.h>
#include <grp.h>
#include <pwd.h>
#include <unistd.h>
#include <fcntl.h>



class TMTools
{
public:
	TMTools();
	virtual ~TMTools();
	
	//Factory method
	static TMTools * Instance ();
	
	virtual struct stat * GetAttr (char * file, Error * e); //has to be cleaned by the user
	virtual void SetMode (char * file, mode_t st_mode, Error * e);
	virtual bool IsDirectory (const StrPtr & path, Error * e = NULL);
	virtual bool FileExists (const char * path, Error * e = NULL);
	virtual bool IsNullFile (const StrPtr & path, Error * e = NULL);
	void TouchFile (char * file, Error * e = NULL);	
	void UnlinkFile (char * file, Error * e = NULL);
	void Mkdir (char * path, Error * e = NULL);		
	
protected:
	virtual void SetErrorMsg (Error * e, ErrorSeverity s, const char *fmt, ...);
	virtual StrBuf & GetDescription ();

private:
	static TMTools * _self;
	
};

#endif //_TMTOOLS_H_
